
from lxml import etree


def evaluate_xpath(root, xpath):
    """
    """
    result = root.xpath(xpath, namespaces=root.nsmap)
    print(xpath, result)
    if result:
        if isinstance(result, list):
            return result[0]
        return result
    return None


def extract_product_type_and_level(metadata_files, config):
    """
    """
    product_type = None
    product_level = None
    for metadata_file in metadata_files:
        with open(metadata_file) as f:
            tree = etree.parse(f)
            root = tree.getroot()

        if not product_type:
            xpaths = config['type_extractor']['xpath']
            xpaths = [xpaths] if isinstance(xpaths, str) else xpaths
            for xpath in xpaths:
                product_type = evaluate_xpath(root, xpath)
                if product_type:
                    break

        if not product_level:
            xpaths = config['level_extractor']['xpath']
            if xpaths:
                xpaths = [xpaths] if isinstance(xpaths, str) else xpaths
                for xpath in xpaths:
                    product_level = evaluate_xpath(root, xpath)
                    if product_level:
                        break

        if product_type and product_level:
            break

    return product_type, product_level